"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var transaction_1 = require("./transaction");
var Account = (function () {
    function Account(numTransactions, id, code, userId, type, status, name, currency, transactions, created) {
        this.id = id;
        this.code = code;
        this.userId = userId;
        this.type = type;
        this.status = status;
        this.name = name;
        this.currency = currency;
        this.transactions = transactions;
        this.created = created;
        this.balance = 0;
        this.numTransactions = (_.isUndefined(numTransactions) || numTransactions == null ? this.transactions.length : numTransactions);
        this.calculatebalance();
        if (this.id === undefined) {
            this.id = '';
        }
    }
    Account.fromJson = function (obj) {
        var items = _.orderBy(_.chain(obj.transactions).values().map(transaction_1.Transaction.fromJson).value(), ['created']);
        return new Account(Number(obj.numTransactions), obj.id, obj.code, obj.userId, obj.type, obj.status, obj.name, obj.currency, items, obj.created);
    };
    Account.prototype.toJson = function () {
        var accountJson = {
            id: this.id,
            code: this.code,
            userId: this.userId,
            type: this.type,
            status: this.status,
            name: this.name,
            currency: this.currency,
            transactions: [],
            numTransactions: this.getItemsCount(),
            balance: this.getbalance(),
            created: this.created
        };
        return accountJson;
    };
    Account.prototype.calculatebalance = function () {
        var _this = this;
        this.balance = 0;
        this.transactions.forEach(function (transaction) {
            _this.balance += transaction.getCost();
        });
    };
    Account.prototype.setItemsCount = function () { this.numTransactions = this.transactions.length; };
    Account.prototype.getItemsCount = function () { return this.numTransactions; };
    Account.prototype.getType = function () { return this.type; };
    Account.prototype.getTransactions = function () { return this.transactions; };
    Account.prototype.getbalance = function () { return this.balance; };
    return Account;
}());
exports.Account = Account;
//# sourceMappingURL=account.js.map