"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var ionic_angular_1 = require("ionic-angular");
var products_provider_1 = require("../product/products.provider");
var store_provider_1 = require("../store/store.provider");
var barcode_scanner_1 = require("@ionic-native/barcode-scanner");
require("rxjs/add/operator/map");
var _ = require("lodash");
var BarcodeData = (function () {
    function BarcodeData(text, format) {
        this.text = text;
        this.format = format;
    }
    return BarcodeData;
}());
exports.BarcodeData = BarcodeData;
var BarcodeProvider = (function () {
    function BarcodeProvider(http, navController, productsProvider, storeProvider, barcodeScanner) {
        this.http = http;
        this.navController = navController;
        this.productsProvider = productsProvider;
        this.storeProvider = storeProvider;
        this.barcodeScanner = barcodeScanner;
        this.data = null;
    }
    BarcodeProvider.prototype.click = function (Page) {
        var _this = this;
        this.barcodeScanner.scan()
            .then(function (result) {
            if (!result.cancelled) {
                var barcodeData = new BarcodeData(result.text, result.format);
                _this.load(barcodeData.text, Page);
            }
        })
            .catch(function (err) {
            alert(err);
        });
    };
    BarcodeProvider.prototype.load = function (scannedData, Page) {
        var _this = this;
        var values = scannedData.split('?');
        return new Promise(function (resolve) {
            var tenantId = values[0];
            var storeId = values[1];
            var productId = values[2];
            _this.storeProvider.retrieveByTenant(tenantId).then(function (stores) {
                var store = _.find(stores, function (o) { return o.id === storeId; });
                _this.productsProvider.retrieve(tenantId, storeId).then(function (products) {
                    var product = _this.productsProvider.getProduct(productId);
                    _this.navController.push(Page, {
                        prod: product, store: store
                    });
                });
            });
        });
    };
    return BarcodeProvider;
}());
BarcodeProvider.decorators = [
    { type: core_1.Injectable },
];
BarcodeProvider.ctorParameters = function () { return [
    { type: http_1.Http, },
    { type: ionic_angular_1.NavController, },
    { type: products_provider_1.ProductsProvider, },
    { type: store_provider_1.StoreProvider, },
    { type: barcode_scanner_1.BarcodeScanner, },
]; };
exports.BarcodeProvider = BarcodeProvider;
//# sourceMappingURL=barcode.provider.js.map