/// <reference types="moment" />
import * as moment from 'moment';
export interface CalEvent {
    id: string;
    calendarId: string;
    tenantId: string;
    storeId: string;
    userId: string;
    title: string;
    start: moment.Moment;
    end: moment.Moment;
    notes: string;
    confirmedStatus: boolean;
    booking: Booking;
}
export interface Booking {
    enabled: boolean;
    seated: boolean;
    touchpointId: string;
    customers: string[];
    customersNum: number;
    phone: number;
}
export declare class Calendar {
    calendarId: string;
    tenantId: string;
    storeId: string;
    userId: string;
    title: string;
    createdOn: moment.Moment;
    calEvents: CalEvent[];
    static createDummyCalendar(): Calendar;
    static createDummyEvent(): CalEvent;
    static fromJson(obj: any): Calendar;
    static bookingFromJson(obj: any): Booking;
    static eventFromJson(obj: any): CalEvent;
    static updateOrPushCalendar(calendarToUpdate: Calendar, calendars: Calendar[]): void;
    static deleteCalendar(calendarToDelete: Calendar, calendars: Calendar[]): void;
    static updateOrPushEvent(eventToUpdate: CalEvent, events: CalEvent[]): void;
    static deleteEvent(eventToDelete: CalEvent, events: CalEvent[]): void;
    constructor(calendarId: string, tenantId: string, storeId: string, userId: string, title: string, createdOn: moment.Moment, calEvents?: CalEvent[]);
    findEvent(eventId: string): CalEvent;
    getCalendarId(): string;
    getTenantId(): string;
    getStoreId(): string;
    getUserId(): string;
    getTitle(): string;
    getCreatedOn(): moment.Moment;
    getCalEvents(): CalEvent[];
}
