import { Product } from '../product/product';
export interface ExportMe {
}
export declare class CartItem {
    product: Product;
    quantity: number;
    courseId: string;
    size: string;
    colour: string;
    printer: object;
    cost: number;
    static fromJson(obj: any): CartItem;
    toJson(): any;
    constructor(product: Product, quantity: number, courseId?: string, size?: string, colour?: string, printer?: object);
    updateItemQuantity(updatedQuantity: number): void;
    getCost(): number;
    getProduct(): Product;
    getQuantity(): number;
    getSize(): string;
    getColour(): string;
    getCourseId(): string;
    getPrinter(): object;
}
export declare class Cart {
    storeId: string;
    tenantId: string;
    userId: string;
    cartItems: CartItem[];
    status: string;
    id: string;
    tableId: string;
    created: string;
    __v: string;
    _rev: string;
    cartCost: number;
    private numItems;
    static fromJson(obj: any): Cart;
    toJson(): any;
    constructor(numItems: number, storeId?: string, tenantId?: string, userId?: string, cartItems?: CartItem[], status?: string, id?: string, tableId?: string, created?: string, __v?: string, _rev?: string);
    calculateCartCost(): void;
    private findItemInCartItems(keyItem);
    private findProductInCartItems(keyId);
    addCartItem(newItem: CartItem): void;
    removeCartItem(idOfProductToRemove: string): void;
    getItem(prodId: string): CartItem;
    incrementQuantity(prodId: string): CartItem;
    decrementQuantity(prodId: string): CartItem;
    setItemsCount(): void;
    getItemsCount(): number;
    getStoreId(): string;
    getStatus(): string;
    getCartItems(): CartItem[];
    getCartCost(): number;
    getTableId(): string;
}
