"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Customer = (function () {
    function Customer(tenantId, firstName, lastName, avatar, gender, id, social, badges, addresses, telephones, storeId, userId) {
        this.tenantId = tenantId;
        this.firstName = firstName;
        this.lastName = lastName;
        this.avatar = avatar;
        this.gender = gender;
        this.id = id;
        this.social = social;
        this.badges = badges;
        this.addresses = addresses;
        this.telephones = telephones;
        this.storeId = storeId;
        this.userId = userId;
    }
    Customer.fromJson = function (obj) {
        return new Customer(obj.tenantId, obj.firstName, obj.lastName, obj.avatar, obj.gender, obj.id, obj.social, obj.badges, obj.addresses, obj.telephones, obj.storeId, obj.userId);
    };
    Customer.prototype.toJson = function () {
        var customerJson = {
            id: this.getId(),
            tenantId: this.getTenantId(),
            firstName: this.getFirstName(),
            lastName: this.getLastName(),
            social: this.getSocial(),
            badges: this.getBadges(),
            addresses: this.getAddresses(),
            telephones: this.getTelephones(),
            storeId: this.getStoreId(),
            userId: this.getUserId()
        };
        return customerJson;
    };
    Customer.prototype.getTenantId = function () { return this.tenantId; };
    Customer.prototype.getFirstName = function () { return this.firstName; };
    Customer.prototype.getLastName = function () { return this.lastName; };
    Customer.prototype.getAvatar = function () { return this.avatar; };
    Customer.prototype.getGender = function () { return this.gender; };
    Customer.prototype.getId = function () { return this.id; };
    Customer.prototype.getSocial = function () { return this.social; };
    Customer.prototype.getBadges = function () { return this.badges; };
    Customer.prototype.getEngaged = function () { return this.badges["engaged"]; };
    Customer.prototype.getVip = function () { return this.badges["vip"]; };
    Customer.prototype.getInstore = function () { return this.badges["inStore"]; };
    Customer.prototype.getAddresses = function () { return this.addresses; };
    Customer.prototype.getTelephones = function () { return this.telephones; };
    Customer.prototype.getStoreId = function () { return this.storeId; };
    Customer.prototype.getUserId = function () { return this.userId; };
    return Customer;
}());
exports.Customer = Customer;
//# sourceMappingURL=client.js.map