import { Http } from '@angular/http';
import 'rxjs/add/operator/map';
import { ApiProvider } from '../api/api.provider';
import { Subject } from 'rxjs/Subject';
import { Customer } from './client';
export declare class ClientProvider {
    http: Http;
    api: ApiProvider;
    clients: Customer[];
    allClients: Customer[];
    clientsObservable: Subject<Customer[]>;
    clientObservable: Subject<Customer>;
    instore: Customer[];
    instoreObservable: Subject<Customer[]>;
    isManager: boolean;
    constructor(http: Http, api: ApiProvider);
    setManagerStatus(rank: boolean): void;
    getManagerStatus(): boolean;
    getCustomersInStore(tenantId: string, storeId: string): any;
    getCustomers(tenantId: string, storeId: string): any;
    loadClients(tenantId: string, storeId: string): Promise<{}>;
    loadClientsInStore(tenantId: string, storeId: string): Promise<{}>;
    getCustomersDetails(tenantId: string, storeId: string, userId: string, customerId?: string): any;
    createCustomer(tenantId: string, storeId: string, fname: string, lname: string, social: any, addresses: any, telephones: any, badges: any): any;
    updateCustomer(customerUpdate: Customer): Promise<{}>;
    deserializeCustomers(incoming: any): Customer[];
    testCustomer(): void;
    checkIn(tenantId: string, storeId: string, userId: string, inStore: string, customerId?: string): any;
    engaged(tenantId: string, storeId: string, userId: string, touchpointId: string, inStore?: string, customerId?: string): any;
}
