"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var api_provider_1 = require("../../services/api/api.provider");
require("rxjs/add/operator/map");
var configuration_1 = require("./configuration");
var ConfigProvider = (function () {
    function ConfigProvider(apiProvider) {
        this.apiProvider = apiProvider;
        this.config = {};
    }
    ConfigProvider.prototype.retrieveByApp = function (tenantId, appId) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/config/" + tenantId + "/" + appId, payload)
                .then(function (response) {
                if (response.id) {
                    _this.config = response;
                    console.log(configuration_1.Configuration.fromJson(_this.config));
                    resolve(configuration_1.Configuration.fromJson(_this.config));
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    ConfigProvider.prototype.retrieveAutoConfig = function (setupCode) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/config/auto/" + setupCode, payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return ConfigProvider;
}());
ConfigProvider.decorators = [
    { type: core_1.Injectable },
];
ConfigProvider.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
]; };
exports.ConfigProvider = ConfigProvider;
//# sourceMappingURL=configuration.provider.js.map