"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var api_provider_1 = require("../../services/api/api.provider");
require("rxjs/add/operator/map");
var ContentProvider = (function () {
    function ContentProvider(apiProvider) {
        this.apiProvider = apiProvider;
    }
    ContentProvider.prototype.create = function (contentParameters) {
        var _this = this;
        var payload = contentParameters;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', "/v1/content", payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    ContentProvider.prototype.retrieveUserHome = function (lat, lng) {
        var _this = this;
        var payload = { 'lat': 'randomLat', 'lng': 'randomLang' };
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/home", payload)
                .then(function (response) {
                if (response[0].id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    ContentProvider.prototype.retrieveByTenant = function (tenantId, type) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/content/" + tenantId + "/" + type, payload)
                .then(function (response) {
                resolve(response);
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    ContentProvider.prototype.retrieveContentDetails = function (id) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/content/" + id, payload)
                .then(function (response) {
                resolve(response);
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return ContentProvider;
}());
ContentProvider.decorators = [
    { type: core_1.Injectable },
];
ContentProvider.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
]; };
exports.ContentProvider = ContentProvider;
//# sourceMappingURL=content.provider.js.map