"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var coupon_1 = require("./coupon");
var api_provider_1 = require("../../services/api/api.provider");
require("rxjs/add/operator/map");
var _ = require("lodash");
var CouponProvider = (function () {
    function CouponProvider(apiProvider) {
        this.apiProvider = apiProvider;
    }
    CouponProvider.prototype.create = function (couponParameters) {
        var _this = this;
        var payload = couponParameters.toJson();
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', "/v1/coupon", payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    CouponProvider.prototype.retrieveByid = function (couponId) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/coupon/" + couponId, payload)
                .then(function (response) {
                if (response.id) {
                    resolve(coupon_1.Coupon.fromJson(response));
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    CouponProvider.prototype.retrieveForLoggedUser = function () {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            if (_.isUndefined(_this.coupons)) {
                _this.apiProvider.api('GET', "/v1/coupons", payload)
                    .then(function (response) {
                    _this.coupons = _.map((_.values(response)), coupon_1.Coupon.fromJson);
                    console.log(_this.coupons);
                    resolve(_this.coupons);
                }, function (err) {
                    reject(err);
                });
            }
            else
                resolve(_this.coupons);
        });
        return promise;
    };
    CouponProvider.prototype.changestatus = function (id, status) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('PATCH', "/v1/coupon/" + id + "/status/" + status, payload)
                .then(function (response) {
                var coupon = coupon_1.Coupon.fromJson(response);
                var position = _this.coupons.findIndex(function (item) { return item.id === coupon.id; });
                _this.coupons.splice(position, 1, coupon);
                console.log(coupon);
                resolve(coupon);
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return CouponProvider;
}());
CouponProvider.decorators = [
    { type: core_1.Injectable },
];
CouponProvider.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
]; };
exports.CouponProvider = CouponProvider;
//# sourceMappingURL=coupon.provider.js.map