"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var ionic_angular_1 = require("ionic-angular");
var local_notifications_1 = require("@ionic-native/local-notifications");
var LocalNotificationProvider = (function () {
    function LocalNotificationProvider(http, navController, localNotifications) {
        this.http = http;
        this.navController = navController;
        this.localNotifications = localNotifications;
    }
    LocalNotificationProvider.prototype.schedule = function (userName, store) {
        this.localNotifications.schedule({
            id: 1,
            title: 'Welcome to ' + store.name + ' ' + userName + '!',
            text: 'What are you looking for today?',
            at: new Date(new Date().getTime() + 5 * 1000),
            sound: null,
            led: 'FF0000',
            data: { mode: 'visit_shop', target: store }
        });
    };
    return LocalNotificationProvider;
}());
LocalNotificationProvider.decorators = [
    { type: core_1.Injectable },
];
LocalNotificationProvider.ctorParameters = function () { return [
    { type: http_1.Http, },
    { type: ionic_angular_1.NavController, },
    { type: local_notifications_1.LocalNotifications, },
]; };
exports.LocalNotificationProvider = LocalNotificationProvider;
//# sourceMappingURL=local-notification.provider.js.map