/// <reference types="moment" />
import { Product } from '../product/product';
import * as moment from 'moment';
export declare class Offer {
    offerId: string;
    tenantId: string;
    customerId: string;
    storeId: string;
    productId: string;
    name: string;
    description: string;
    discountedPrice: number;
    img_url: string;
    created: moment.Moment;
    discountRate: number;
    product: Product;
    static createDummyOffer(): Offer;
    static fromJson(obj: any): Offer;
    static pushOfferIfUnique(offerToPush: Offer, offers: Offer[]): void;
    static updateOrPushOffer(offerToUpdate: Offer, offers: Offer[]): void;
    static deleteOffer(offerToDelete: Offer, offers: Offer[]): void;
    constructor(offerId: string, tenantId: string, customerId: string, storeId: string, productId: string, name: string, description: string, discountedPrice: number, img_url: string, created: moment.Moment);
    getOfferId(): string;
    getTenantId(): string;
    getCustomerId(): string;
    getStoreId(): string;
    getProductName(): string;
    getProductDescription(): string;
    getProductImgUrl(): string;
    getCreationDate(): moment.Moment;
    getProduct(): Product;
    getProductId(): string;
    getDiscountRate(): number;
    getDiscountedPrice(): number;
    setProduct(prod: Product): void;
}
