import { Observable } from 'rxjs/Observable';
import { Subject } from 'rxjs/Subject';
import 'rxjs/add/operator/map';
import { Offer } from './offer';
import { ApiProvider } from '../api/api.provider';
export declare class OffersProvider {
    apiProvider: ApiProvider;
    _offers$: Subject<Offer[]>;
    dataStore: {
        offers: Offer[];
    };
    readonly offers$: Observable<Offer[]>;
    constructor(apiProvider: ApiProvider);
    initOffers(tenantId: string, storeId: string): Promise<Offer[]>;
    createOffer(tenantId: string, storeId: string, productId: string, name: string, description: string, discountedPrice: number, img_url: string): Promise<Offer>;
    retrieveOffers(tenantId: string, storeId: string): Promise<Offer[]>;
    retrieveOfferDetails(offerId: string): Promise<Offer>;
    updateOffer(offerId: string, tenantId: string, storeId: string, productId: string, name: string, description: string, discountedPrice: number, img_url: string): Promise<Offer>;
    deleteOffer(offerId: string): Promise<Offer>;
}
