"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Product = (function () {
    function Product(id, name, brand, description, price, img_url, category, tenantId, sku, __v, printer) {
        this.id = id;
        this.name = name;
        this.brand = brand;
        this.description = description;
        this.price = price;
        this.img_url = img_url;
        this.category = category;
        this.tenantId = tenantId;
        this.sku = sku;
        this.__v = __v;
        this.printer = printer;
    }
    Product.fromJson = function (obj) {
        return new Product(obj.id, obj.name, obj.brand ? obj.brand : 'HARD_CODED_BRAND', obj.description ? obj.description : 'HARD_CODED_DESCRIPTION', obj.price, obj.thumb ? obj.thumb : 'HARD_CODED_IMG_URL', obj.category ? obj.category : 'HARD_CODED_CATEGORY', obj.tenantId ? obj.tenantId : 'HARD_CODED_TENANT', obj.sku ? obj.sku : 'HARD_CODED_SKU', obj.__v ? obj.__v : '', obj.printer ? obj.printer : 'HARD_CODED_PRINTER');
    };
    Product.inCartFromJson = function (obj) {
        return new Product(obj.productId, obj.title, obj.brand ? obj.brand : 'HARD_CODED_BRAND', obj.description ? obj.description : 'HARD_CODED_DESCRIPTION', obj.price, obj.img_url ? obj.img_url : 'HARD_CODED_IMG_URL', obj.category ? obj.category : 'HARD_CODED_CATEGORY', obj.tenantId ? obj.tenantId : 'HARD_CODED_TENANT', obj.sku ? obj.sku : undefined, obj.__v ? obj.__v : '', obj.printer ? obj.printer : undefined);
    };
    Product.prototype.toJson = function () {
        var productJson = {
            productId: this.getId(),
            title: this.getName(),
            finalPrice: this.getPrice(),
            img_url: this.getImgUrl(),
            __v: this.__v,
            printer: this.getPrinter(),
            sku: this.sku
        };
        return productJson;
    };
    Product.prototype.getId = function () { return this.id; };
    Product.prototype.getName = function () { return this.name; };
    Product.prototype.getBrand = function () { return this.brand; };
    Product.prototype.getDescription = function () { return this.description; };
    Product.prototype.getPrice = function () { return this.price; };
    Product.prototype.getImgUrl = function () { return this.img_url; };
    Product.prototype.getCategory = function () { return this.category; };
    Product.prototype.getTenantId = function () { return this.tenantId; };
    Product.prototype.getPrinter = function () { return this.printer; };
    Product.prototype.getSKU = function () { return this.sku; };
    return Product;
}());
exports.Product = Product;
//# sourceMappingURL=product.js.map