"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var api_provider_1 = require("./api/api.provider");
require("rxjs/add/operator/map");
var Observable_1 = require("rxjs/Observable");
var Subject_1 = require("rxjs/Subject");
var cart_provider_1 = require("./cart/cart.provider");
var SampleService = (function () {
    function SampleService(apiProvider, cartprovider) {
        this.apiProvider = apiProvider;
        this.cartprovider = cartprovider;
        this.testNumber = 0;
        this.testObservable = Observable_1.Observable.create(this.testNumber);
        this.obTest = new Subject_1.Subject();
    }
    SampleService.prototype.increase = function () {
        this.testNumber++;
        this.obTest.next(this.testNumber);
    };
    SampleService.prototype.decrease = function () {
        this.testNumber--;
        this.obTest.next(this.testNumber);
    };
    SampleService.prototype.getcurrentNumber = function () {
        this.obTest.next(this.testNumber);
        return this.obTest.asObservable();
    };
    SampleService.prototype.initCurrentNumber = function () {
        this.obTest.next(this.testNumber);
    };
    SampleService.prototype.createCalendar = function () {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', '/v1/calendar', payload)
                .then(function (response) {
                if (response.id) {
                }
                else {
                    reject('Error cart#1');
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    SampleService.prototype.retrieveCalendar = function (tenantId, storeId) {
        var _this = this;
        var payload;
        if (storeId) {
            payload = {
                store_id: storeId
            };
        }
        var promise = new Promise(function (resolve, reject) {
            if (tenantId) {
                payload.tenant_id = tenantId;
                _this.apiProvider.api('GET', '/v1/calendars', payload)
                    .then(function (response) {
                    resolve(response);
                }, function (response) {
                    reject(response);
                });
            }
            else {
                reject();
            }
        });
        return promise;
    };
    SampleService.prototype.retrieveCalendarsDetails = function (tenantId, storeId, calendarId) {
        var _this = this;
        var payload;
        if (storeId) {
            payload = {
                store_id: storeId
            };
        }
        var promise = new Promise(function (resolve, reject) {
            if (tenantId) {
                payload.tenant_id = tenantId;
                _this.apiProvider.api('GET', '/v1/calendar/' + calendarId, payload)
                    .then(function (response) {
                    resolve(response);
                }, function (response) {
                    reject(response);
                });
            }
            else {
                reject();
            }
        });
        return promise;
    };
    SampleService.prototype.createEvent = function (calendarId, eventDetails) {
        var _this = this;
        var payload = eventDetails;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', '/v1/calendar/' + calendarId, payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return SampleService;
}());
SampleService.decorators = [
    { type: core_1.Injectable },
];
SampleService.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
    { type: cart_provider_1.CartsProvider, },
]; };
exports.SampleService = SampleService;
//# sourceMappingURL=sample.service.js.map