"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var StoreDetailsProvider = (function () {
    function StoreDetailsProvider(http) {
        this.http = http;
    }
    StoreDetailsProvider.prototype.load = function (currentProvider, storeId) {
        var _this = this;
        if (this.store) {
            return Promise.resolve(this.store);
        }
        return new Promise(function (resolve) {
            _this.http.get(currentProvider + 'stores/' + storeId)
                .map(function (res) { return res.json(); })
                .subscribe(function (data) {
                _this.store = data;
                resolve(_this.store);
            }, function (err) {
                console.error('Error fetching store details from API\n', err);
            });
        });
    };
    return StoreDetailsProvider;
}());
StoreDetailsProvider.decorators = [
    { type: core_1.Injectable },
];
StoreDetailsProvider.ctorParameters = function () { return [
    { type: http_1.Http, },
]; };
exports.StoreDetailsProvider = StoreDetailsProvider;
//# sourceMappingURL=store-details.provider.js.map