"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var store_1 = require("./store");
var api_provider_1 = require("../../services/api/api.provider");
require("rxjs/add/operator/map");
var _ = require("lodash");
var StoreProvider = (function () {
    function StoreProvider(apiProvider) {
        this.apiProvider = apiProvider;
    }
    StoreProvider.prototype.create = function (storeParameters) {
        var _this = this;
        var payload = storeParameters;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', "/v1/store", payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    StoreProvider.prototype.retrieve = function (storeId) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/store/" + storeId, payload)
                .then(function (response) {
                if (response.id) {
                    console.log(_this.stores);
                    resolve(store_1.Store.fromJson(response));
                }
                else {
                    reject();
                }
            })
                .catch(function (err) { return reject(err); });
        });
        return promise;
    };
    StoreProvider.prototype.retrieveByTenant = function (tenantId) {
        var _this = this;
        var payload = {};
        payload.tenantId = tenantId;
        var promise = new Promise(function (resolve, reject) {
            if (_.isUndefined(_this.stores)) {
                _this.apiProvider.api('GET', "/v1/stores", payload)
                    .then(function (response) {
                    _this.stores = _.map((_.values(response)), store_1.Store.fromJson);
                    console.log(_this.stores);
                    resolve(_this.stores);
                }, function (err) {
                    reject(err);
                });
            }
            else
                resolve(_this.stores);
        });
        return promise;
    };
    StoreProvider.prototype.retrieveByLocation = function (tenantId, coords, radius) {
        var _this = this;
        var payload = {};
        payload.tenantId = tenantId;
        payload.radius = radius;
        payload.coords = coords;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/stores", payload)
                .then(function (response) {
                _this.stores = _.map((_.values(response)), store_1.Store.fromJson);
                console.log(_this.stores);
                resolve(_this.stores);
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    StoreProvider.prototype.TestByTennat = function () {
        var _this = this;
        var payload = {};
        payload.tenantId = '57b540a3d4c62844f361a893';
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/stores", payload)
                .then(function (response) {
                _this.stores = _.map((_.values(response)), store_1.Store.fromJson);
                console.log(_this.stores);
                resolve(_this.stores);
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    StoreProvider.prototype.TestByLocation = function (tenantId, coords, radius) {
        var _this = this;
        var payload = {};
        payload.tenantId = tenantId;
        payload.radius = radius;
        payload.coords = coords;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/stores", payload)
                .then(function (response) {
                _this.stores = _.map((_.values(response)), store_1.Store.fromJson);
                console.log(_this.stores);
                resolve(_this.stores);
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return StoreProvider;
}());
StoreProvider.decorators = [
    { type: core_1.Injectable },
];
StoreProvider.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
]; };
exports.StoreProvider = StoreProvider;
//# sourceMappingURL=store.provider.js.map