"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var api_provider_1 = require("../../services/api/api.provider");
require("rxjs/add/operator/map");
var TenantProvider = (function () {
    function TenantProvider(apiProvider) {
        this.apiProvider = apiProvider;
    }
    TenantProvider.prototype.create = function (tenantParameters) {
        var _this = this;
        var payload = tenantParameters;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', "/v1/tenant", payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    TenantProvider.prototype.retrieve = function (tenantId) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/tenant/" + tenantId, payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return TenantProvider;
}());
TenantProvider.decorators = [
    { type: core_1.Injectable },
];
TenantProvider.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
]; };
exports.TenantProvider = TenantProvider;
//# sourceMappingURL=tenant.provider.js.map