"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var api_provider_1 = require("../../services/api/api.provider");
require("rxjs/add/operator/map");
var UserEventProvider = (function () {
    function UserEventProvider(apiProvider) {
        this.apiProvider = apiProvider;
    }
    UserEventProvider.prototype.create = function (userId, userEventParameters) {
        var _this = this;
        var payload = userEventParameters;
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('POST', "/v1/user/" + userId + "/event", payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    UserEventProvider.prototype.retrieveDetails = function (userId, eventId) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/user/" + userId + "/event/" + eventId, payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    UserEventProvider.prototype.retrieveDetailsAlternative = function (eventId) {
        var _this = this;
        var payload = {};
        var promise = new Promise(function (resolve, reject) {
            _this.apiProvider.api('GET', "/v1/userevent/" + eventId, payload)
                .then(function (response) {
                if (response.id) {
                    resolve(response);
                }
                else {
                    reject();
                }
            }, function (err) {
                reject(err);
            });
        });
        return promise;
    };
    return UserEventProvider;
}());
UserEventProvider.decorators = [
    { type: core_1.Injectable },
];
UserEventProvider.ctorParameters = function () { return [
    { type: api_provider_1.ApiProvider, },
]; };
exports.UserEventProvider = UserEventProvider;
//# sourceMappingURL=user-events.provider.js.map