import { CartItem } from '../cart/cart';
import { Product } from '../product/product';
export declare class WishList {
    tenantId: string;
    wishItems: WishItem[];
    type: string;
    name: string;
    userId: string;
    id: string;
    wishCost: number;
    static fromJson(obj: any): WishList;
    toJson(): any;
    constructor(tenantId: string, wishItems: WishItem[], type: string, name: string, userId: string, id?: string);
    calculateWishlistCost(): void;
    private findItemInWishlistItems(keyItem);
    private findProductInWishlistItems(keyId);
    deleteWishlist(): void;
    addWishlistItem(newItem: WishItem): void;
    removeWishlistItem(idOfProductToRemove: string): void;
    getItem(prodId: string): WishItem;
    incrementQuantity(prodId: string): void;
    decrementQuantity(prodId: string): void;
    getWishlistCost(): number;
    getItemsCount(): number;
    getTenantId(): string;
    getWishlistItems(): WishItem[];
}
export declare class WishItem {
    private cartItem;
    storeId: string;
    cost: number;
    static fromJson(obj: any): WishItem;
    toJson(): any;
    constructor(cartItem: CartItem, storeId: string);
    updateItemQuantity(updatedQuantity: number): void;
    getCost(): number;
    getProduct(): Product;
    getQuantity(): number;
    getSize(): string;
    getColour(): string;
    getStoreId(): string;
    getCartItem(): CartItem;
}
