import { ApiProvider } from '../api/api.provider';
import { Subject } from 'rxjs/Subject';
import { WishList, WishItem } from './wishlist';
import 'rxjs/add/operator/map';
export declare class WishListsProvider {
    apiProvider: ApiProvider;
    wishlists: WishList[];
    currentWishlist: WishList;
    wishListObservable: Subject<WishList>;
    wishListsObservable: Subject<WishList[]>;
    constructor(apiProvider: ApiProvider);
    wishlistState(result: any): void;
    emptyWishlist(tenantId?: any, id?: string, name?: string, user?: string, type?: string): {
        'id': string;
        'userId': string;
        'name': string;
        'tenantId': any;
        '__v': string;
        'created': string;
        'items': any[];
        'numItems': number;
        'type': string;
    };
    create(tenantId: string, name: string, type: string): Promise<{}>;
    updateList(wishlist: WishList, userId: string): Promise<{}>;
    delete(cartId: string): Promise<{}>;
    addItem(cartId: string, product: WishItem): Promise<{}>;
    deleteItem(cartId: string, product: WishItem, batch?: boolean): Promise<{}>;
    emptyList(id: string): void;
    retrieveByUser(tenantId: string, userId: string): Promise<{}>;
    retrieve(): Promise<{}>;
    retrieveListDetails(cartId: string, tenantId: string): Promise<{}>;
    retrieveListItem(cartId: string, productId: string): Promise<{}>;
    updateListItem(cartId: string, cItem: WishItem): Promise<{}>;
    retrieveDez(cartId: string): Promise<{}>;
    deserializeWishlist(incoming: any): WishList;
    deserializeWishlists(incoming: any): WishList[];
}
