import { Injectable } from '@angular/core';
import { ApiProvider } from '../../services/api/api.provider';
import 'rxjs/add/operator/map';
import { Configuration } from './configuration';
// import * as _ from 'lodash';

// touchpoint holder
// current touchpoint
// observable?

// Generated class for the Touchpoint provider. 
// See https://angular.io/docs/ts/latest/guide/dependency-injection.html
// for more info on providers and Angular 2 DI.
@Injectable()
export class ConfigProvider {

  config: any;
  constructor( public apiProvider: ApiProvider) {
    this.config = {};
  }

  retrieveByApp(tenantId: string, appId: string) {
    let payload: any = {};
    let promise = new Promise((resolve, reject) => {
      this.apiProvider.api('GET', `/v1/config/${tenantId}/${appId}` , payload)
      .then((response: any) => {
        // returns array!!
        if (response.id) {
          this.config = response;
          // CURRENT
          console.log(Configuration.fromJson(this.config));
          resolve(Configuration.fromJson(this.config));
        } else {
          reject();
        }
      },  (err) => { // catch error
        // @todo: We should check for errors ?!?
        reject(err);
      });
    });
    return promise;
  }

  retrieveAutoConfig(setupCode: string) {
    // http://{{url}}/v1/config/auto
    let payload: any = {};
    let promise = new Promise((resolve, reject) => {
      this.apiProvider.api('GET', `/v1/config/auto/${setupCode}` , payload)
      .then((response: any) => {
        // returns array!!
        if (response.id) {
          resolve(response);
        } else {
          reject();
        }
      },  (err) => { // catch error
        // @todo: We should check for errors ?!?
        reject(err);
      });
    });
  return promise;
  }
}
